#pragma once
#include <string>
#include <type_traits>
#include <ostream>



namespace chat
{
    enum class message : char
    {
        HELLO = 1, NEPTUN = 2, PASSW = 3,
        SERVER_DIRECTION = 4, MESSAGE = 5,
        PING = 6, PONG = 7, BYE = 8,
        LOGIN = 9, LOGOUT = 10, TERM = 0x7f
    };


    class chat_message
    {
        message _header;
        std::string _content;

    public:
        chat_message(message header, std::string content = "")
                : _header(header), _content(content)
        {}

        chat_message(std::underlying_type<message>::type header_integral, std::string content)
                : _header(static_cast<message>(header_integral)), _content(content)
        {}

        std::string get() const
        { return static_cast<char>(_header) + _content + static_cast<char>(message::TERM); }
    };


    std::ostream& operator<<(std::ostream& os, const chat_message& msg)
    { return os << msg.get(); }
}